/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package test;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.QueueBrowser;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TopicConnectionFactory;
import javax.management.JMException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

public class QueueSenderServlet extends HttpServlet {
    
    @Resource(mappedName = "jms/txTestConnectionFactory")
    private QueueConnectionFactory txTestConnectionFactory;

    @Resource(mappedName = "jms/mdbTriggerQueue")
    private Queue mdbTriggerQueue;
    
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            String testStr = (String)request.getParameter("test");
            String cftypeStr = (String)request.getParameter("cftype");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet QueueSenderServlet</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet QueueSenderServlet at " + request.getContextPath () + "</h1>");
            int testNum=Integer.parseInt(testStr);
           
            out.println("Test case = "+testNum+" starting<br>");
            switch (testNum) {
                case 1:  test1(out); break;                  
            default: System.out.println("Invalid test case "+testNum);break;
            }
            out.println("Test case = "+testNum+" successfully completed<br>");

        } catch (Exception e){
            out.println("<p>Something bad happened. Here's what I know:</p>");
            out.println("<pre>");
            e.printStackTrace(out);
           out.println("</pre>");
        }
        out.println("</body>");
        out.println("</html>");
        out.close();
    } 
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private void test1(PrintWriter out) throws Exception {
        
        Connection connection = txTestConnectionFactory.createConnection();
        Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
        MessageProducer producer = session.createProducer(mdbTriggerQueue);
        
        int numMessages=40;
        for (int i = 0; i < numMessages; i++) {
            TextMessage message = session.createTextMessage("Here is the news");
            producer.send(message);
        }                  
        connection.close();
        out.println("<p>Sent "+numMessages+" messages to queue</p>");

    }
}
